package fishrungames.yelpmapapp

import android.os.AsyncTask
import com.google.gson.JsonObject


/**
 * Created by mephi on 10.06.2017.
 */


class HandleResponseAsyncTask(val onUpdateMapMarkers : ((Map<String, MapMarkerRecord>) -> Unit)) : AsyncTask<JsonObject, Int, Map<String, MapMarkerRecord>>()
{

    override fun doInBackground(vararg response : JsonObject): Map<String, MapMarkerRecord> {

        val newMapMarkers = mutableMapOf<String, MapMarkerRecord>()

        try {

            for (businessElement in response[0].getAsJsonArray("businesses")) {
                val businessJson = businessElement.asJsonObject

                val id = businessJson.get("id").asString
                val name = businessJson.get("name").asString
                val image_url = businessJson.get("image_url").asString
                val latitude = businessJson.get("coordinates").asJsonObject.get("latitude").asDouble
                val longitude = businessJson.get("coordinates").asJsonObject.get("longitude").asDouble

                var mapMarker = MapMarkerRecord(id, name, image_url, latitude, longitude)

                newMapMarkers[name] = mapMarker

            }

        }
        catch (e : Exception)
        {
            e.printStackTrace()

        }

        return newMapMarkers
    }

    override fun onPostExecute(result: Map<String, MapMarkerRecord>) {
        super.onPostExecute(result)

        onUpdateMapMarkers(result)

    }
}